<?php if ( ! defined( 'ABSPATH' ) ) exit;

/*
Plugin Name: درگاه پرداخت پی استار برای افزونه EDD وردپرس
Plugin URI: http://paystar.ir
Description: <b> درگاه پرداخت پی استار برای افزونه EDD وردپرس </b>
Version: 1.0
Author: ModuleBank
Author URI: http://www.modulebank.ir
 */

function edd_add_gateway_paystar($gateways)
{
	return array_merge($gateways, array(
				'paystar' => array(
					'admin_label'    => 'پی استار',
					'checkout_label' => 'پی استار',
					'supports'       => array('buy_now')
				)
			)
		);
}
add_filter('edd_payment_gateways', 'edd_add_gateway_paystar');

function edd_send_to_gateway_paystar($purchase_data)
{
	global $edd_options;
	$payment_data = array(
			'price'        => $purchase_data['price'], 
			'date'         => $purchase_data['date'], 
			'user_email'   => $purchase_data['post_data']['edd_email'],
			'purchase_key' => $purchase_data['purchase_key'],
			'currency'     => $edd_options['currency'],
			'downloads'    => $purchase_data['downloads'],
			'cart_details' => $purchase_data['cart_details'],
			'user_info'    => $purchase_data['user_info'],
			'status'       => 'pending'
		);
	if ($payment = edd_insert_payment($payment_data))
	{
		require_once(dirname(__FILE__) . '/paystar_payment_helper.class.php');
		$p = new PayStar_Payment_Helper($edd_options['paystar_terminal']);
		$r = $p->paymentRequest(array(
				'amount'   => intval(ceil($purchase_data['price'])),
				'order_id' => $payment . '#' . time(),
				'name'     => @$purchase_data['post_data']['edd_first'].' '.@$purchase_data['post_data']['edd_last'],
				'mail'     => @$purchase_data['post_data']['edd_email'],
				'phone'    => @$purchase_data['post_data']['edd_phone'],
				'callback' => add_query_arg(array('listener' => 'paystar-edd', 'paymentId' => $payment), get_permalink($edd_options['success_page']))
			));
		if ($r)
		{
			$p->redirect();
		}
		else
		{
			echo $p->error;
		}
		exit;
	}
	else
	{
		edd_send_back_to_checkout('?payment-mode='.$purchase_data['post_data']['edd-gateway']);
	}
}
add_action('edd_gateway_paystar', 'edd_send_to_gateway_paystar');

function edd_gateway_paystar_verify()
{
	if (isset($_GET['listener'],$_POST['status'],$_POST['order_id'],$_POST['ref_num']) && $_GET['listener'] == 'paystar-edd')
	{
		global $edd_options;
		list($paymentId, $nothing) = explode('#', $_POST['order_id']);
		$amount = intval(ceil(edd_get_payment_amount($paymentId)));
		require_once(dirname(__FILE__) . '/paystar_payment_helper.class.php');
		$p = new PayStar_Payment_Helper($edd_options['paystar_terminal']);
		$r = $p->paymentVerify(array_merge($_POST, array('amount' => $amount)));
		if ($r)
		{
			$message = "Payment Completed. PaymentRefrenceId : {$p->txn_id}";
			edd_update_payment_status($paymentId, 'publish');
			edd_insert_payment_note($paymentId, $message);
			edd_insert_payment_note($paymentId, print_r($_POST,1));
			edd_send_to_success_page();
			edd_empty_cart();
		}
		else
		{
			edd_insert_payment_note($paymentId, 'Error : '.$p->error);
			edd_insert_payment_note($paymentId, 'Error : '.print_r($p,1));
			edd_insert_payment_note($paymentId, print_r($_POST,1));
			edd_update_payment_status($paymentId, 'failed');
			wp_redirect( get_permalink($edd_options['failure_page']) );
			exit;
		}
	}
}
add_action('init', 'edd_gateway_paystar_verify');

function edd_gateway_paystar_setting($settings)
{
	return array_merge( $settings, array (
				array (
					'id'   => 'paystar_setting',
					'name' => 'PayStar Setting',
					'desc' => 'PayStar Setting',
					'type' => 'header'
				),
				array (
					'id'   => 'paystar_terminal',
					'name' => 'PayStar Terminal',
					'desc' => 'PayStar Terminal',
					'type' => 'text',
					'size' => 'regular'
				),
			)
		);
}
add_filter('edd_settings_gateways', 'edd_gateway_paystar_setting');

function edd_paystar_cc_form_filter(){}
add_filter( 'edd_paystar_cc_form', 'edd_paystar_cc_form_filter' );

?>